// (c) Copyright 2012 Cloudera, Inc. All rights reserved.
define([
    "cloudera/Util",
    "cloudera/common/TimeUtil",
    "underscore"
], function(Util, TimeUtil, _) {
  /**
   * Implements a simple refresher that triggers
   * a markerDateChanged event. This is used
   * when the time control is not present (Free Edition),
   * but we need to let components on the page to auto update.
   *
   * Today, almost all updates are triggered by
   * markerDateChanged or timeSelectionChanged event.
   */
  return Class.extend({

    init: function(options) {
      var self = this;
      var refresh = function() {
        // Don't trigger the event if there are opened menus.
        if (!self.hasOpenMenu()) {
          $.publish("markerDateChanged", [TimeUtil.getServerNow(), true]);
        }
        _.delay(refresh, options.updateIntervalInMS);
      };

      if (!Util.getTestMode()) {
        _.delay(refresh, options.updateIntervalInMS);
      }
    },

    hasOpenMenu: function() {
      return $(".open .dropdown-toggle").length !== 0;
    }
  });
});
