// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/Util","cloudera/common/Humanize","cloudera/common/TimeUtil"],function(e,t,n){describe("Humanize",function(){it("should test humanizeBytes.",function(){expect(t.humanizeBytes(13)).toEqual("13 B"),expect(t.humanizeBytes(1024)).toEqual("1.0 KiB"),expect(t.humanizeBytes(1536)).toEqual("1.5 KiB"),expect(t.humanizeBytes(5629499534213120)).toEqual("5.0 PiB"),expect(t.humanizeBytes(0x1f40000000000000)).toEqual("2.0 EiB"),expect(t.humanizeBytes(-0x1f40000000000000)).toEqual("-2.0 EiB")}),it("should test humanizeSeconds.",function(){expect(t.humanizeSeconds(13)).toEqual("13.00s"),expect(t.humanizeSeconds(120)).toEqual("2.0m"),expect(t.humanizeSeconds(7200)).toEqual("2.0h"),expect(t.humanizeSeconds(172800)).toEqual("2.0d")}),it("should test humanizeTimeShortAndMS",function(){var e=new Date(100101);expect(t.humanizeTimeShortAndMS(e)).toEqual("4:01:40.101 PM")}),it("should test humanizeMilliSeconds.",function(){expect(t.humanizeMilliseconds(13)).toEqual("13ms"),expect(t.humanizeMilliseconds(279)).toEqual("279ms"),expect(t.humanizeMilliseconds(989)).toEqual("989ms"),expect(t.humanizeMilliseconds(1234)).toEqual("1.23s"),expect(t.humanizeMilliseconds(79.123456153432)).toEqual("79ms"),expect(t.humanizeMilliseconds(1500)).toEqual("1.50s"),expect(t.humanizeMilliseconds(55e3)).toEqual("55.00s"),expect(t.humanizeMilliseconds(9e4)).toEqual("90.00s"),expect(t.humanizeMilliseconds(12e4)).toEqual("2.0m"),expect(t.humanizeMilliseconds(36e5)).toEqual("60.0m"),expect(t.humanizeMilliseconds(72e5)).toEqual("2.0h")}),it("should test humanizeDateTimeMedium",function(){var e=new Date(100101);expect(t.humanizeDateTimeMedium(e)).toEqual("December 31 1969 4:01 PM")}),it("should test humanizeDateLong",function(){var e=new Date(100101);expect(t.humanizeDateLong(e)).toEqual("December 31 1969")}),it("should test humanizeDateTimeLong",function(){var e=new Date(100101);expect(t.humanizeDateTimeLong(e)).toEqual("Wednesday, December 31 1969 4:01 PM")}),it("should test humanizeDateShort.",function(){var e=new Date(100101);expect(t.humanizeDateShort(e)).toEqual("12/31/1969")}),it("should test humanizeTimeShort",function(){var e=new Date(100101);expect(t.humanizeTimeShort(e)).toEqual("4:01 PM")}),it("should test humanizeTimeShortAndMS",function(){var e=new Date(100101);expect(t.humanizeTimeShortAndMS(e)).toEqual("4:01:40.101 PM")}),it("should test humanizeTimeMedium",function(){var e=new Date(100101);expect(t.humanizeTimeMedium(e)).toEqual("4:01:40 PM")}),it("should test humanizeTimeLong",function(){var e=new Date(100101);expect(t.humanizeTimeLong(e)).toEqual("16:01:40.101 -0800")}),it("should test humanizeDateNoYear",function(){var e=new Date(100101);expect(t.humanizeDateNoYear(e)).toEqual("Dec 31")}),it("should test humanizeDateJustMonth",function(){var e=new Date(100101);expect(t.humanizeDateJustMonth(e)).toEqual("Dec")}),it("should test humanizeDateJustYear",function(){var e=new Date(100101);expect(t.humanizeDateJustYear(e)).toEqual("1969")}),describe("adaptable",function(){var e,r;beforeEach(function(){r=moment.lang(),e=new Date(2012,10,14,11,45),spyOn(n,"getServerNow").andReturn(e)}),afterEach(function(){moment.lang(r)}),it("should pad minutes with two digits",function(){var e=new Date(2012,10,14,11,0),n=t.humanizeDateTimeAdaptable(e);expect(n).toEqual("11:00 AM")}),it("should show earlier today correctly",function(){var e=new Date(2012,10,14,11,30),n=t.humanizeDateTimeAdaptable(e);expect(n).toEqual("11:30 AM")}),it("should show yesterday correctly",function(){var e=new Date(2012,10,13,11,0),n=t.humanizeDateTimeAdaptable(e);expect(n).toEqual("Nov 13 11:00 AM")})}),describe("adaptable with seconds",function(){var e,r;beforeEach(function(){r=moment.lang(),e=new Date(2012,10,14,11,45),spyOn(n,"getServerNow").andReturn(e)}),afterEach(function(){moment.lang(r)}),it("should pad minutes with two digits",function(){var e=new Date(2012,10,14,11,0,32),n=t.humanizeDateTimeAdaptable(e,!0);expect(n).toEqual("11:00:32 AM")}),it("should show earlier today correctly",function(){var e=new Date(2012,10,14,11,30,14),n=t.humanizeDateTimeAdaptable(e,!0);expect(n).toEqual("11:30:14 AM")}),it("should show yesterday correctly",function(){var e=new Date(2012,10,13,11,0,53),n=t.humanizeDateTimeAdaptable(e,!0);expect(n).toEqual("Nov 13 11:00:53 AM")})})})})