// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/health/spec/HealthTestUtil","cloudera/health/HealthHistory","cloudera/chart/TimeRange","knockout","underscore"],function(e,t,n,r,i){describe("HealthHistory",function(){var n=null,s;beforeEach(function(){jasmine.Ajax.useMock(),n={id:"hhId",healthCheckUrl:"healthCheckUrl",eventSearchUrl:"eventSearchUrl",startTime:new Date(20),endTime:new Date(2e3)},s=new t(n)}),afterEach(function(){s.unsubscribe()}),it("only lets itself be started once",function(){expect(s.started).toBeFalsy(),spyOn(s,"getEvents"),s.start(),expect(s.getEvents.callCount).toEqual(1),expect(s.started).toBeTruthy()}),it("defines itself correctly",function(){expect(s.id).toEqual(n.id),expect(s.healthCheckUrl).toEqual(n.healthCheckUrl),expect(s.eventSearchUrl).toEqual(n.eventSearchUrl),expect(s.query).toBeDefined(),expect(s.viewModel).not.toBeDefined()}),it("sets good defaults for the event search query",function(){expect(s.query.startTime).toEqual(new Date(0)),expect(s.query.endTime).toEqual(n.endTime),expect(s.query.offset).toEqual(0),expect(s.query.limit).toEqual(20)}),it("gets new events when the TC updates",function(){var e=spyOn(s,"onMarkerDateChanged");s.start(),$.publish("markerDateChanged",[new Date]),expect(e).wasCalled()}),describe("event search query options",function(){var e=function(e){expect(e.propertyName).toEqual("CATEGORY"),expect(e.compareType).toEqual("EQ_WITH_OR"),expect(e.values).toEqual(["HEALTH_CHECK"])},r=function(e,t,n){expect(e.propertyName).toEqual(t),expect(e.compareType).toEqual("EQ_WITH_OR"),expect(e.values).toEqual([n])},o=function(e,t){expect(e.propertyName).toEqual("EVENTCODE"),expect(e.compareType).toEqual("EQ_WITH_OR"),expect(e.values.length).toEqual(5);var n="_"+t.toUpperCase()+"_HEALTH_CHECK_";i.each(e.values,function(e){expect(e.indexOf(n)!==-1).toBeTruthy()})};it("works when service is set",function(){n.service="service",s=new t(n),expect(s.query.filters.length).toEqual(3),e(s.query.filters[0]),r(s.query.filters[1],"SERVICE",n.service),o(s.query.filters[2],"SERVICE")}),it("works when role is set",function(){n.role="role",s=new t(n),expect(s.query.filters.length).toEqual(3),e(s.query.filters[0]),r(s.query.filters[1],"ROLE",n.role),o(s.query.filters[2],"ROLE")}),it("works when host is set",function(){n.host="host",s=new t(n),expect(s.query.filters.length).toEqual(3),e(s.query.filters[0]),r(s.query.filters[1],"HOSTS",n.host),o(s.query.filters[2],"HOST")})}),it("sets viewModel on initial call to onEventsResponse",function(){expect(s.viewModel).not.toBeDefined(),s.onEventsResponse(i.map(i.range(5),e.makeFakeHealthEvent)),expect(s.viewModel).toBeDefined()}),it("only applies bindings the first time onEventsResponse is called",function(){spyOn(r,"applyBindings"),s.onEventsResponse(i.map(i.range(5),e.makeFakeHealthEvent)),expect(r.applyBindings).wasCalled(),s.onEventsResponse(i.map(i.range(5,10),e.makeFakeHealthEvent)),expect(r.applyBindings.callCount).toEqual(1)})}),describe("HealthHistoryViewModel",function(){var n=t.HealthHistoryViewModel,r;beforeEach(function(){r=i.map(i.range(10),e.makeFakeHealthEvent)}),it("exists",function(){expect(n).toBeDefined()}),it("has a loading property that is always true",function(){var e=new n(r);expect(e.loaded()).toBeTruthy()}),it("makes an events array based on server response",function(){var e=new n(r);expect(e.events().length).toEqual(10)}),it("places events in order as more come in during updates",function(){r=i.map(i.range(5,15),e.makeFakeHealthEvent);var t=new n(r);expect(t.events()[0].id).toEqual(r[0].attributes.__uuid[0]);var s=i.map(i.range(0,10),e.makeFakeHealthEvent);t.update(s,new Date(r[9].timestamp),new Date(s[0].timestamp)),expect(t.events().length).toEqual(15),i.each(i.range(10),function(e){expect(t.events()[e].id).toEqual(s[e].attributes.__uuid[0])}),i.each(i.range(11,15),function(e){expect(t.events()[e].id).toEqual(r[e-5].attributes.__uuid[0])})}),it("discards new events when timerange is smaller than previous",function(){r=i.map(i.range(0,10),e.makeFakeHealthEvent);var t=new n(r);expect(t.events()[0].id).toEqual(r[0].attributes.__uuid[0]);var s=i.map(i.range(3,7),e.makeFakeHealthEvent);t.update(s,new Date(s[3].timestamp),new Date(s[0].timestamp)),expect(t.events().length).toEqual(4),i.each(t.events(),function(e,t){expect(e.id).toEqual(s[t].attributes.__uuid[0])})}),describe("HealthEvent property additions",function(){var t,s;beforeEach(function(){r=i.map(i.range(10),e.makeFakeHealthEvent),i.each(r,function(e){e.attributes.GOOD_TEST_RESULTS=[1],e.attributes.BAD_TEST_RESULTS=[2],e.attributes.CONCERNING_TEST_RESULTS=[3],e.attributes.DISABLED_TEST_RESULTS=[4],e.attributes.UNKNOWN_TEST_RESULTS=[5]}),s=new n(r),t=s.events()[0]}),it("has formattedTimestamp",function(){expect(t.formattedTimestamp).toBeDefined()}),it("appends seconds if the previous event was within 60 seconds",function(){var t=10,o=0,u=0,a,f;r=i.map(i.range(t),e.makeFakeHealthEvent),f=r[0].timestamp,i.each(r,function(e){e.attributes.GOOD_TEST_RESULTS=[1],e.attributes.BAD_TEST_RESULTS=[2],e.attributes.CONCERNING_TEST_RESULTS=[3],e.attributes.DISABLED_TEST_RESULTS=[4],e.attributes.UNKNOWN_TEST_RESULTS=[5],o++<4&&(e.timestamp=f,f-=5e4)}),s=new n(r),a=s.events(),i.each(a,function(e){expect(e.formattedTimestamp).toMatch(u++>=4?/(?:^| )\d{1,2}:\d{1,2} (?:A|P)M$/:/(?:^| )(?:\d{1,2}:){2}\d{1,2} (?:A|P)M$/)})}),it("tracks expansion and toggles",function(){expect(t.expanded()).toBeFalsy(),t.toggleExpansion(),expect(t.expanded()).toBeTruthy()}),it("formats health text using I18n",function(){expect(t.healthText).toEqual("ui.health.bad")}),it("has formatted status counts by status",function(){var e=t.formattedStatusCounts;expect(e.good).toEqual("health.changes.green"),expect(e.bad).toEqual("health.changes.red"),expect(e.concerning).toEqual("health.changes.yellow"),expect(e.disabled).toEqual("health.changes.disabled"),expect(e.unknown).toEqual("health.changes.not_avail")}),it("breaks out health tests results as custom objects",function(){expect(t.healthTests).toBeDefined(),expect(t.healthTests.length).toEqual(1);var e=t.healthTests[0];expect(e.shortName).toEqual("health.test.descriptor.data_node_host_health.description.short"),expect(e.status).toEqual("concerning"),expect(e.content).toEqual("The health test result for DATA_NODE_HOST_HEALTH has become concerning: The health of this role's host is concerning.  The following health checks are concerning: agent status.")})})})})